function [names,value,parind,local,upper,lower,thetamu,thetasig] = ...
    openparstruct(parstruct,nbatch)
%OPENPARSTRUCT parameter struct utility for mcmc tbx
% [names,value,parind,local,upper,lower,thetamu,thetasig] = ...
%    openparstruct(parstruct,nbatch)

% $Revision: 1.4 $  $Date: 2005/09/06 15:46:58 $

ntheta    = length(parstruct);
local     = [];
npar      = ntheta;

ii = 0;
%% scan for local variables
for i=1:length(parstruct)
  ii = ii+1;
  local(ii) = 0;
  if length(parstruct{i})>7
    if parstruct{i}{8}
      local(ii:(ii+nbatch-1)) = 1:nbatch;
%     ntheta=ntheta+nbatch-1; 
      npar=npar+nbatch-1;
      ii = ii+nbatch-1;
      for k=2:7
        if length(parstruct{i}{k})~=nbatch
          if length(parstruct{i}{k})==1
            parstruct{i}{k} = parstruct{i}{k}*ones(1,nbatch);
          else
            error(sprintf('Not enough values for %s',parstruct{i}{1}))
          end
        end
      end
    end
  end
end

%local

value     = zeros(npar,1);
names     = cell(npar,1);
upper     = ones(1,npar)*Inf;
lower     = -ones(1,npar)*Inf;
thetamu   = zeros(1,npar);
thetasig  = ones(1,npar,1)*Inf;
parind    = ones(npar,1);

ii = 0;
for i=1:ntheta
  ii = ii+1;
  %  assignin('base',parstruct{i}{1},parstruct{i}{2});
  if local(ii) == 0
    names{ii}   = parstruct{i}{1};
    value(ii)   = parstruct{i}{2};
    
    if length(parstruct{i})>2 & ~isempty(parstruct{i}{3})
      lower(ii)    = parstruct{i}{3};
    end
    if length(parstruct{i})>3 & ~isempty(parstruct{i}{4})
      upper(ii)    = parstruct{i}{4};
    end
    if length(parstruct{i})>=6 
      thetamu(ii)  = parstruct{i}{5};
      thetasig(ii) = parstruct{i}{6};
      if isnan(thetamu(ii))
        thetamu(ii)=value(ii);
      end
      if thetasig(ii) == 0
        thetasig(ii) = Inf;
      end
    end
    if length(parstruct{i})>=7 & parstruct{i}{7}==0% parind-flagi
      parind(ii) = 0;
    end
  
  else
    
    iii = ii:(ii+nbatch-1);
    if nbatch==1
        names(iii(1))    = {sprintf('%s',parstruct{i}{1})};
    else
      for k=1:nbatch
        names(iii(k))    = {sprintf('%s[%d]',parstruct{i}{1},k)};
      end
    end
    value(iii)    = parstruct{i}{2};

    if length(parstruct{i})>2 & ~isempty(parstruct{i}{3})
      lower(iii)    = parstruct{i}{3};
    end
    if length(parstruct{i})>3 &~isempty(parstruct{i}{4})
      upper(iii)    = parstruct{i}{4};
    end
    if length(parstruct{i})>=6 
      thetamu(iii)  = parstruct{i}{5};
      thetasig(iii) = parstruct{i}{6};

      iiii = isnan(thetamu(iii));
      thetamu(iiii) = value(iiii);
      thetasig(thetasig(iii)==0) = Inf;
%      if isnan(thetamu(i))
%        thetamu(iii)=value(i);
%      end
%      if thetasig(iii) == 0
%        thetasig(iii) = Inf;
%      end
    end
    if length(parstruct{i})>=7 & parstruct{i}{7}==0% parind-flagi
      parind(iii) = 0;
    end

    ii = ii + nbatch - 1 ;
    
  end
  
end
parind = find(parind);

%local=0; %%%%%% not implemented yet
